---
title: Update Mapping
description: The PUT {{apiPath}}/v1/environments/{{envID}}/propagation/mappings/{{mappingID}} operation updates the property values of the identified identity propagation mapping resource.
component: pingone-api
page_id: pingone-api:platform:identity-propagation-provisioning/propagation-mappings/update-mapping
canonical_url: https://developer.pingidentity.com/pingone-api/platform/identity-propagation-provisioning/propagation-mappings/update-mapping.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Update Mapping

##

```none
PUT {{apiPath}}/v1/environments/{{envID}}/propagation/mappings/{{mappingID}}
```

The `PUT {{apiPath}}/v1/environments/{{envID}}/propagation/mappings/{{mappingID}}` operation updates the property values of the identified identity propagation mapping resource.

### Prerequisites

* Refer to [Identity Propagation (Provisioning)](../../identity-propagation-provisioning.html) for important overview information.

> **Collapse: Request Model**
>
> Refer to [Propagation mapping data model](../propagation-mappings.html#propagation-mapping-data-model) for full property descriptions.
>
> | Property          | Type   | Required?         |
> | ----------------- | ------ | ----------------- |
> | `expression`      | String | Required/Optional |
> | `name`            | String | Optional          |
> | `rule.id`         | String | Required          |
> | `sourceAttribute` | String | Required/Optional |
> | `targetAttribute` | String | Required          |

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "rule": {
        "id": "{{ruleID}}"
    },
    "sourceAttribute": "username",
    "targetAttribute": "accountId"
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff --request PUT '{{apiPath}}/v1/environments/{{envID}}/propagation/mappings/{{mappingID}}' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "rule": {
        "id": "{{ruleID}}"
    },
    "sourceAttribute": "username",
    "targetAttribute": "accountId"
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/propagation/mappings/{{mappingID}}")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Put);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""rule"": {" + "\n" +
@"        ""id"": ""{{ruleID}}""" + "\n" +
@"    }," + "\n" +
@"    ""sourceAttribute"": ""username""," + "\n" +
@"    ""targetAttribute"": ""accountId""" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/propagation/mappings/{{mappingID}}"
  method := "PUT"

  payload := strings.NewReader(`{
    "rule": {
        "id": "{{ruleID}}"
    },
    "sourceAttribute": "username",
    "targetAttribute": "accountId"
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
PUT /v1/environments/{{envID}}/propagation/mappings/{{mappingID}} HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "rule": {
        "id": "{{ruleID}}"
    },
    "sourceAttribute": "username",
    "targetAttribute": "accountId"
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"rule\": {\n        \"id\": \"{{ruleID}}\"\n    },\n    \"sourceAttribute\": \"username\",\n    \"targetAttribute\": \"accountId\"\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/propagation/mappings/{{mappingID}}")
  .method("PUT", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/propagation/mappings/{{mappingID}}",
  "method": "PUT",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "rule": {
      "id": "{{ruleID}}"
    },
    "sourceAttribute": "username",
    "targetAttribute": "accountId"
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'PUT',
  'url': '{{apiPath}}/v1/environments/{{envID}}/propagation/mappings/{{mappingID}}',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "rule": {
      "id": "{{ruleID}}"
    },
    "sourceAttribute": "username",
    "targetAttribute": "accountId"
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/propagation/mappings/{{mappingID}}"

payload = json.dumps({
  "rule": {
    "id": "{{ruleID}}"
  },
  "sourceAttribute": "username",
  "targetAttribute": "accountId"
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("PUT", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/propagation/mappings/{{mappingID}}');
$request->setMethod(HTTP_Request2::METHOD_PUT);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "rule": {\n        "id": "{{ruleID}}"\n    },\n    "sourceAttribute": "username",\n    "targetAttribute": "accountId"\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/propagation/mappings/{{mappingID}}")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Put.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "rule": {
    "id": "{{ruleID}}"
  },
  "sourceAttribute": "username",
  "targetAttribute": "accountId"
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"rule\": {\n        \"id\": \"{{ruleID}}\"\n    },\n    \"sourceAttribute\": \"username\",\n    \"targetAttribute\": \"accountId\"\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/propagation/mappings/{{mappingID}}")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "PUT"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

200 OK

```json
{
    "id": "eec9bfac-9e59-495f-ace7-0bf8a44b864f",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "createdAt": "2022-01-13T21:39:10.695Z",
    "updatedAt": "2022-01-13T21:41:01.098Z",
    "rule": {
        "id": "f9d4c0fc-269d-4645-9079-2795b18f06a6"
    },
    "sourceAttribute": "username",
    "targetAttribute": "accountId",
    "_links": {
        "get": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/propagation/mappings/eec9bfac-9e59-495f-ace7-0bf8a44b864f"
        },
        "create": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/propagation/rules/f9d4c0fc-269d-4645-9079-2795b18f06a6/mappings"
        },
        "update": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/propagation/mappings/eec9bfac-9e59-495f-ace7-0bf8a44b864f"
        },
        "delete": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/propagation/mappings/eec9bfac-9e59-495f-ace7-0bf8a44b864f"
        }
    }
}
```
